#include "../lib/snmp_api.h"
#include "../lib/snmp_asn1.h"

/* 
  * "RETURN CHAR" COMMANDS
  ********* */
char * snmpCmd(snmp_session *sess, char *oids, char *values, char *types, int norep, int maxrep, int snmpType);
Packet * walkit(snmp_session *s, Packet *req, Packet *rcv);

Tuple *mktuple(char *oid, char *value, char *type, int rw);
int linktuples(Tuple *father, Tuple *child);
void freetuple(Tuple *t);

Pdu* mkpdu(void);
void freepdu(Pdu *p);

Packet* mkpkt(void);
int linkpkt(Packet *father, Packet *child);
int fillpkt(Packet * pkt, snmp_session *sess, int type, char *oids, char *values, char *types, int nonrep, int maxrep);
void freepkt(Packet * p);

int mkreqid(void);

/* 
  * "PRINT" COMMANDS
  ********* */
char * dumppkt(Packet *s);

/* 
  * OTHER COMMANDS
  ********* */
/* Used to decide if the walk proccess migth continue o stop */
int canwalk(Packet *header, Packet *torcv);
int iseom(Packet *pkt);
int isnotsuchobj(Packet *pkt);