#include "../lib/asn1.h"
#include "../lib/snmp_session.h"

/* snmp structures */
typedef struct Pdu Pdu;
typedef struct Tuple Tuple;
typedef struct Packet Packet;
typedef struct Traps Traps;


struct Pdu {
	uchar type;	/* for all PDUs */
	int reqid;		/* for all PDUs */
	int errstat;		/* for all PDUs */
	int erridx;		/* for all PDUs */
	int nrep;		/* getbulk */
	int maxrep;	/* getbulk */
	int tlen;		/* getbulk */
	Tuple *tuple;
};

struct Packet {
	int version;
	char *comm;
	Pdu *pdu;
	Packet *nextpkt;
};

struct Traps {
	char *oid;
	char *addr;
	int type;
	char *ts;
	Tuple *tuple;
};


struct Tuple {
	char *oid;
	char *value;
	char *type;
	Tuple *nexttuple;
};


/* Petition Types, not PDU types for snmp.h, yes to snmp_api, kix solve it */
enum {
	GetRequest 		= 0xa0,
	GetNextRequest 	= 0xa1,
	GetResponse 		= 0xa2,
	SetRequest 		= 0xa3,
	Trap 			= 0xa4,
	GetBulkRequest 	= 0xa5,
	InformRequest 		= 0xa6,
	SNMPv2Trap 		= 0xa7,
	SnmpWalk		= 0x99		/* special */
};


int alarmtr(void *v, char *why);
Elem mkvarbind(Tuple *tuple);
Elist* snmpbulk(Packet *pkt);
Elist* snmprequest(Packet *pkt);
int encpkt(snmp_session *sess, Packet *pkt, Bytes **pbytes);
int snmpTalk(snmp_session *sess, Packet *snd, Packet *rcv);
Elem mkSNMPpdu(int type, Elist *el);
int decpdu(Elist *el, Packet *pkt);
int decpkt(uchar *buff, int bufflen, Packet *pkt);
