/* Header file for snmp from/to asn1 */
#define MAX_ELEM	32		/* kix, try to remove it */

/* snmp asn1 primitive types */
enum {
	IpAddress			= 0x40,
	Counter			= 0x41,
	Gauge			= 0x42,
	TimeTicks			= 0x43,
	Opaque			= 0x44,
	NsapAddress		= 0x45,
	Counter64		= 0x46,
	UIInteger32		= 0x47,
	NoSuchObject		= 0x80,
	NoSuchInstance 	= 0x81,
	EndOfMIB			= 0x82
};

/* To create types */
Elist * mkrequest(int type, Elem reqid, Elem f1, Elem f2, Elem el);
Ints * snmp_mkoid(char *str);
Elem mkelem(int type, Elist *el);

/* To convert types */
char * asn2char(Elem e);
Elem char2asn(char *data, char *type);
Elem oid2asn(char *s);
int pdu2asn(Elem *epdu, Elem *e);

/* To delete types */
int freerequest(Elist *list);
int freepelem(Elem *element);

